const get = function (name, data) {
    if (!name) return;
    if (Array.isArray(name)) {
        let result = [];
        for (let n of name) {
            let v = get.call(this, n, data);
            if (v !== undefined) result.push(v);
        }
        return result;
    } else {
        switch (typeof name) {
            case "string":
                let splitStr = this && this.config && this.config.StringSplit ? this.config.StringSplit : ".";
                return getbyStringArray.call(this, name.split(splitStr), data)
            case "function":
                let fname = name();
                return get.call(this, fname, data);
            case "object":
                return getObject.call(this, name, data);
        }
    }
    return;
}
const getbyStringArray = function (name, data) {
    if (Array.isArray(name)) {
        if (name.length === 1) {
            return getbyString.call(this, name[0], data);
        } else if (name.length > 1) {
            let n = name.shift();
            let value = getbyString.call(this, n, data);
            if (value !== undefined && value !== null) return getbyStringArray.call(this, name, value);
            return value;
        }
    }
}
const getbyString = function (name, data) {
    if (name) {
        if (Array.isArray(data)) {
            let result = [];
            for (let d of data) {
                let v = getbyString.call(this, name, d);
                if (v !== undefined) result.push(v);
            }
            return result;
        } else if (name && name[0] === '$') {
            if (this && this.storage && this.storage) {
                if (this.storage[name] && this.storage[name].get) return this.storage[name].get;
                return this.storage[name];
            }
        } else {
            if (!data) return;
            switch (typeof data) {
                case "function":
                    return data.call(this, name);
                case "object":
                    return data[name];
                default:
                    break;
            }
        }
    }
}
const getObject = function (obj, data) {
    let name = obj.Path || obj.Name;
    let value;
    if (name) {
        value = get.call(this, name, data);
        if (value !== undefined) {
            if (obj.Childs) {
                let result;
                for (let f in obj.Childs) {
                    let n = obj.Childs[f];
                    let v = get.call(this, obj.Childs[f], value);
                    if (v) {
                        if (typeof n === 'string') {
                            if (!result) result = {};
                            result[n] = v;
                        } else if (n.Name) {
                            result[n.Name] = v;
                        }
                    }
                }
                value = result;
            }

        }
        if (value === undefined || value === null) {
            if (obj.DefaultValue) value = obj.DefaultValue;
        }
        if (obj.Type) {
        }
        if (value !== undefined) {
            if (obj.Name) return { [obj.Name]: value };
            return value;
        }
    }
    return value;
}

module.exports = get;