
const merge = function () {
    if (arguments.length === 1) return arguments[0];
    if (arguments.length > 1) {
        let a = arguments[0];
        for (let i = 1; i < arguments.length; i++) {
            a = merge2.call(this, a, arguments[i]);
        }
        return a;
    }
    return;
}
const isNull = function (x) {
    return x === undefined;
}
const merge2 = function (a, b) {
    if (a === b) return a;
    if (isNull(a) || a === null) {
        if (Array.isArray(b)) { a = []; }
        else if (typeof b === 'object') { a = {}; } else { return b; }
    }
    if (isNull(b)) return a;
    let context = {
        a: { value: a, type: Array.isArray(a) ? 'array' : (typeof a) },
        b: { value: b, type: Array.isArray(b) ? 'array' : (typeof b) }
    }
    if (context.a.type === 'array' && context.b.type === 'array') return mergeAA.call(this, a, b);
    if (context.a.type === 'array' && context.b.type === 'object') return mergeAO.call(this, a, b);
    //if (context.a.type === 'array' && context.b.type === 'function') return b;//mergeAF(context.a, context.b);
    if (context.a.type === 'array') return mergeAE.call(this, a, b);
    if (context.a.type === 'object' && context.b.type === 'array') return mergeEA.call(this, b, a);
    if (context.a.type === 'object' && context.b.type === 'object') return mergeOO.call(this, a, b);
    //if (context.a.type === 'object' && context.b.type === 'function') return b;//mergeOF(context.a, context.b);
    if (context.a.type === 'object') return a; //return mergeOE(context.a, context.b);
    //if (context.a.type === 'function' && context.b.type === 'array') return b;//return mergeAO(context.b, context.a);
    //if (context.a.type === 'function' && context.b.type === 'object') return b;//return mergeOF(context.b, context.a);
    //if (context.a.type === 'function' && context.b.type === 'function') return b;//return mergeFF(context.a, context.b);
    //if (context.a.type === 'function') return b; //return mergeFE(context.a, context.b);
    if (context.b.type === 'array') return mergeEA.call(this, b, a);
    if (context.b.type === 'object') return merge.call(this, {}, b); //return mergeOE(context.b, context.a);
    // if (context.b.type === 'function') return b; //return mergeFE(context.b, context.a);
    return b; //mergeEE(context.a, context.b); 
}
//合并2个数组
const mergeAA = function (a, b) {
    for (let o of b) { if (typeof o === 'object') { a = mergeAO.call(this, a, o); } else { a = mergeAE.call(this, a, o); } }
    return a;
}
//合并数组和对象
const mergeAO = function (a, b) {
    if (b === null) return null;
    let name = this && this.config && this.config.Name ? this.config.Name : "Name";
    if (name && b[name]) {
        let index = a.findIndex(x => { return x && x[name] === b[name]; });
        if (index > -1) { a[index] = merge.call(this, {}, a[index], b); } else { a = mergeAE.call(this, a, b); }
    } else { a = mergeAE.call(this, a, b); }
    return a;
}
//合并数据和数据
const mergeEA = function (a, b) {
    let index = a.findIndex(x => { return x === b; });
    if (index === -1) {
        let r = [];
        for (let p of a) { r = mergeAE.call(this, r, p); }
        r = mergeAE.call(this, r, b);
        return r;
    }
    return a;
}
//合并数据和数据
const mergeAE = function (a, b) {
    let index = a.findIndex(x => { return x === b; });
    if (index === -1) a.push(merge2.call(this, undefined, b));
    return a;
}
//合并对象和对象
const mergeOO = function (a, b) {
    if (b === null) return null;
    Object.keys(a).forEach(key => { a[key] = merge.call(this, a[key], b[key]); })
    Object.keys(b).forEach(key => { if (isNull(a[key])) a[key] = merge2.call(this, a[key], b[key]); })
    return a;
}

const mergeClass = class {
    constructor(config) { this.config = config }
    merge() { return merge.apply(this, arguments); }
}
module.exports = {
    mergeClass: mergeClass,
    merge: merge
};