const merge = require('./merge').merge;
const set = function (name, value, data) {
    if (!name) return;
    if (Array.isArray(name)) {
        for (let n of name) {
            set.call(this, n, value, data);
        }
    } else {
        switch (typeof name) {
            case "string":
                let splitStr = this && this.config && this.config.StringSplit ? this.config.StringSplit : ".";
                setbyStringArray.call(this, name.split(splitStr), value, data)
                break;
            case "function":
                set.call(this, name(), value, data);
                break;
            case "object":
                setObject.call(this, name, value, data);
                break;
        }
    }
}
const setbyStringArray = function (name, value, data) {
    if (Array.isArray(name)) {
        if (name.length === 1) {
            setbyString.call(this, name[0], value, data);
        } else if (name.length > 1) {
            let n = name.shift();
            //let value = setbyString.call(this, n, value, data);
            // if (data[n] === undefined) {}
            if (n && n[0] === '$') {
                if (this.storage[n] && this.storage[n].set) {
                    this.storage[n].set.call(this, name.join('.'), value);
                } else if (typeof this.storage[n] === 'function') {
                    this.storage[n].call(this, name.join('.'), value);
                }
            } else if (data !== undefined && data !== null) {
                let d = data[n];
                if (typeof d === 'object' && d && !Array.isArray(d)) {
                    setbyStringArray.call(this, name, value, d);
                } else if ((d === undefined || d === null || Array.isArray(d)) && value !== undefined && value !== null) {
                    data[n] = {};
                    setbyStringArray.call(this, name, value, data[n]);
                }
            }
        }
    }
}
const setObject = function (obj, value, data) {
    let name = obj.Path || obj.Name;
    if (name) set.call(this, name, value, data);
}
const setbyString = function (name, value, data) {
    if (name) {
        if (name[0] === '$') {
            let n = name[0];
            if (this.storage[n] && this.storage[n].set) {
                this.storage[n].set.call(this, '', value);
            } else if (typeof this.storage[n] === 'function') {
                this.storage[n].call(this, '', value);
            }
        } else if (data !== undefined && data !== null) {
            if (data[name] && typeof data[name] === 'object' && this && this.config && this.config.Merge === true) {
                console.log('merge', JSON.stringify(merge.call(this, data[name], value)))
                data[name] = merge.call(this, data[name], value);
            }
            else data[name] = value;
        }
    }
}
const setClass = class {
    constructor(storage, config) {
        this.storage = storage;
        this.config = Object.assign({ StringSplit: ".", StorageLetter: "$" }, config);
    }
    set() { return set.apply(this, arguments); }
}


module.exports = { setClass: setClass, set: set };