const typeClass = require('./typeClass');

const Storage = {
    "$empty$": () => { return ''; },
    "$default$": () => { return ''; }
}

class bool extends typeClass {
    constructor(name) {
        super(name);
    }


    get ConvertHandler() {
        return function (value, NullToEmpty) {
            let result = [];
            value.split(',').forEach(t => {
                let k = parseInt(t);
                if (k && !isNaN(k)) result.push(k);
            })
            if (result.length > 0) return result;
            return NullToEmpty ? this.Empty.call(this) : undefined;
        }
    }
    get Empty() {
        return () => { return []; }
    }
    get IsEmpty() {
        return function (value) {
            return Array.isArray(value) && value.length === 0;
        }
    }
    get Is() {
        return (value) => {
            if (Array.isArray(value)) return true;
        }
    }
    get DefaultValue() {
        return () => { return []; }
    }
    get IsDefaultValue() {
        return (value) => {
            return Array.isArray(value) && value.length === 0;
        }
    }
    get StringRegx() {
        return;
    }
    get Storage() {
        return (key) => {
            return Storage[key]();
        }
    }

    get IsStorage() {
        return (key) => {
            return Storage[key] !== undefined;
        }
    }

    get FormatHandler() {
        return (value, NullToEmpty) => {
            if (Array.isArray(value)) { return value; }
            else if (typeof value === 'string') return this.ConvertFromString(value, NullToEmpty);
            return NullToEmpty ? this.Empty.call(this) : undefined;
        }
    }
    get CountHandler() {
        return {}
    }
    get CompareHanlder() {
        return {}
    }
}
module.exports = bool;