const typeClass = require('./typeClass');

let years = 365 * 24 * 3600000;
let months = 30 * 24 * 3600000;
let week = 7 * 24 * 3600000;
let day = 24 * 3600000;
let hour = 3600000;
let monites = 60000;
let second = 1000;
const sp = [
    { k: years, t: '年前', b: "年后", f: "y" },
    { k: months, t: '月前', b: "月后", f: "M" },
    { k: week, t: '周前', b: "周后", f: "w" },
    { k: day, t: '日前', b: "前后", f: "d" },
    { k: hour, t: '小时前', b: "小时后", f: "h" },
    { k: monites, t: '分前', b: "分后", f: "m" },
    { k: second, t: '秒前', b: "秒后", f: "s" },
]

const Add = function (date, timespan, l) {
    let d = new Date(date).getTime();
    let index = sp.findIndex(s => { return s.f === l; });
    if (index > -1) d = sp[index].k * timespan + d;
    return formatDate(new Date(d));

}
const TimeSpan = function (date1, date2) {
    if (date1) {
        if (!date2) date2 = new Date().getTime();
        let key = new Date(date1).getTime() - new Date(date2).getTime();
        if (key === 0) return '现在';
        if (key > 0) {
            for (let s of sp) {
                if (key / s.k > 1) return Math.round(key / s.k) + s.b;
            }
        } else {
            key = key * -1;
            for (let s of sp) {
                if (key / s.k > 1) return Math.round(key / s.k) + s.t;
            }
        }
        return '现在';
    }
    return '';
}
const formatNumber = n => {
    n = n.toString()
    return n[1] ? n : '0' + n
}
const formatDate = function (date, onlydate) {
    if (!date) date = new Date();
    const year = date.getFullYear()
    const month = date.getMonth() + 1
    const day = date.getDate()
    const hour = date.getHours()
    const minute = date.getMinutes()
    const second = date.getSeconds()
    return [year, month, day].map(formatNumber).join('/') + (onlydate ? '' : (' ' + [hour, minute, second].map(formatNumber).join(':')));

}
const Storage = function (value, onlydate) {
    if (!value) return;
    if (value && typeof value === 'string') value = value.toLowerCase();
    if (value === 'empty' || value === '$empty$') return this.Empty.call(this);
    if (value === 'default' || value === '$default$') return this.DefaultValue.call(this);
    if (value === '$now$') return this.DefaultValue.call(this);
    switch (value) {

    }
}
const IsStorage = function (value, onlydate) {
    if (!value) return;
    if (value && typeof value === 'string') value = value.toLowerCase();
    if (value === 'empty') return true;
    if (value === 'default') return true;
    if (value === '$now$') return true;
    if (value[0] === '$' && value[value.length - 1] === '$') return true;
    return false;
}
class date extends typeClass {
    constructor(name, onlydate) {
        super(name);
        this.onlydate = onlydate;
    }


    get ConvertHandler() {
        return (value) => {
            return formatDate(new Date(value), this.onlydate);
        }
    }
    get Empty() {
        return () => { return this.onlydate ? '1970/01/01' : '1970/01/01 00:00:00'; }
    }
    get IsEmpty() {
        return (value) => {
            return value === '' || value === (this.onlydate ? '1970/01/01' : '1970/01/01 00:00:00') || value === (this.onlydate ? '1970-01-01' : '1970-01-01 00:00:00');
        }
    }
    get Is() {
        return (value) => {
            if (typeof value === 'string') {
                if (this.IsStorage.call(this, value)) return true;
                return this.test(value);
            } else if (typeof value === 'object' && value && value.toLocaleString) return true;
            else if (typeof value === 'number') {
                return this.Is.call(this, new Date(value));
            }
            return false;
        }
    }
    get DefaultValue() {
        return () => { return formatDate(new Date(), this.onlydate); }
    }
    get IsDefaultValue() {
        return (value) => {
            return value === formatDate(new Date(), this.onlydate);
        }
    }
    get StringRegx() {
        return [
            /^[1-9]\d{3}-(0[1-9]|1[0-2])-(0[1-9]|[1-2][0-9]|3[0-1])$/,
            /^[1-9]\d{3}\/(0[1-9]|1[0-2])\/(0[1-9]|[1-2][0-9]|3[0-1])$/,
            /^[1-9]\d{3}-(0[1-9]|1[0-2])-(0[1-9]|[1-2][0-9]|3[0-1])\s+(20|21|22|23|[0-1]\d):[0-5]\d:[0-5]\d$/,
            /^[1-9]\d{3}\/(0[1-9]|1[0-2])\/(0[1-9]|[1-2][0-9]|3[0-1])\s+(20|21|22|23|[0-1]\d):[0-5]\d:[0-5]\d$/
        ]
    }
    get Storage() {
        return (key) => {
            return Storage.call(this, key);
        }
    }

    get IsStorage() {
        return (key) => {
            return IsStorage.call(this, key);
        }
    }

    get FormatHandler() {
        return (value, NullToEmpty) => {
            if (typeof value === 'string') {
                return this.ConvertFromString(value, NullToEmpty);
            }
            else if (typeof value === 'number') {
                let v = formatDate(new Date(value), this.onlydate);
                if (this.test.call(this, v)) return v;
                return NullToEmpty ? this.Empty.call(this) : undefined;
            }
            else if (typeof value === 'object' && value && value.toLocaleString) {
                return formatDate(value, this.onlydate);
            }
            return NullToEmpty ? this.Empty.call(this) : undefined;
        }
    }
    get CountHandler() {
        const add = (args) => {
            if (args.length === 0) return;
            if (args.length === 1) return args[0];
            let a = args[1];
            let d = args[2];
            if (['y', 'M', 'd', 'h', 'm', 's'].indexOf(d) > -1) {
                if (typeof a === 'number') {
                    return Add(args[0], a, d);
                }
                else {
                    throw '日期型加法因子有误' + d;
                }
            }
            return args[0];

        }
        const decrease = (args) => {
            if (args.length === 0) return;
            //if (args.length === 1) return args[0];
            let a = args[1];
            let d = args[2];
            if (['y', 'M', 'd', 'h', 'm', 's'].indexOf(d) > -1) {
                if (typeof a === 'number') {
                    return Add(args[0], -1 * a, d);
                } else {
                    throw '日期型加法因子有误' + d;
                }
            } else if (!d) {
                if (a && this.Is(a)) {
                    return TimeSpan(args[0], a);
                } else {
                    //   throw '日期型加法因子有误' + a;
                    return TimeSpan(args[0]);
                }
            }
            return args[0];
        }
        return {
            "-": function () { return decrease(arguments); },
            "+": function () { return add(arguments); }
        }
    }
    get CompareHanlder() {
        return {
            "=": (a, b) => { return a === b; }
        }
    }
}
module.exports = date;