const typeClass = require('./typeClass');

const Storage = {
    "$empty$": () => { return { Id: 0, Type: 0 }; },
    "$default$": () => { return { Id: 0, Type: 0 }; }
}

class bool extends typeClass {
    constructor(name, fields) {
        super(name);
        this.fields = fields;

    }


    get ConvertHandler() {
        return function (value, NullToEmpty) {
            try {
                if (value.indexOf && value.indexOf(':') > -1) {
                    let v = JSON.parse(value);
                    return this.FormatHandler(v, NullToEmpty);
                }
                else {
                    let v = parseInt(value);
                    if (typeof v === 'number' && !isNaN(v)) return { Id: v };
                }
            } catch (e) {
                return NullToEmpty ? this.Empty.call(this) : undefined;
            }
        }
    }
    get Empty() {
        return () => { return { Id: 0, Type: 0 } }
    }
    get IsEmpty() {
        return function (value) {
            return value === '00000000-0000-0000-0000-000000000000';
        }
    }
    get Is() {
        return (value) => {
            if (typeof value === 'string') {
                if (this.IsStorage.call(this, value.toLowerCase())) return true;

            }
            else if (typeof value === 'object' && value.Id !== undefined) return true;
            return false;

        }
    }
    get DefaultValue() {
        return () => { return false; }
    }
    get IsDefaultValue() {
        return (value) => {
            return value === false;
        }
    }
    get StringRegx() {
        return;
    }
    get Storage() {
        return (key) => {
            return Storage[key]();
        }
    }

    get IsStorage() {
        return (key) => {
            return Storage[key] !== undefined;
        }
    }

    get FormatHandler() {
        return (value, NullToEmpty) => {
            if (typeof value === 'object') {
                if (value.Id !== undefined) {
                    let v = { Id: parseInt(value.Id) };
                    if (value.Type !== undefined) v.Type = parseInt(value.Type);
                    return v;
                }
            } else if (typeof value === 'string') return this.ConvertFromString(value, NullToEmpty);
            return NullToEmpty ? this.Empty.call(this) : undefined;
        }
    }
    get CountHandler() {

        return {

        }
    }
    get CompareHanlder() {
        return {

        }
    }
    get Fields() {
        return this.fields;
    }
}
module.exports = bool;