const typeClass = require('./typeClass');
const Count = function (a, b, l) {
    //if (typeof a !== 'string' || typeof b !== 'string') return undefined;
    let value;
    switch (l) {
        case '+':
            value = a + b;
            break;
    }
    return value;
}

class string extends typeClass {
    constructor(name, config) {
        super(name);
        this.config = config;
        this.config.Storage = Object.assign({
            Storage: {
                "$empty$": () => { return this.Empty(); },
                "$default$": () => { return this.DefaultValue(); }
            }
        }, this.config.Storage);

    }


    get ConvertHandler() {
        return function (value) { return value; }
    }
    get Empty() {
        return () => { return this.config.empty || ''; }
    }
    get IsEmpty() {
        return function (value) {
            return value === (this.config.empty || '');
        }
    }
    get Is() {
        return (value) => {
            if (typeof value !== 'string') return false;
            if (this.IsStorage.call(this, value)) return true;
            if (!this.test(value)) return false;
            return true;
        }
    }
    get DefaultValue() {
        return () => { return this.config.defaultvalue || ''; }
    }
    get IsDefaultValue() {
        return (value) => {
            return value === this.DefaultValue();
        }
    }
    get StringRegx() {
        return this.config.regx;
    }
    get Storage() {
        return (key) => {
            return this.config.Storage[key]();
        }
    }

    get IsStorage() {
        return (key) => {
            return this.config.Storage[key] !== undefined;
        }
    }

    get FormatHandler() {
        return (value, NullToEmpty) => {
            if (typeof value === 'string') {
                return this.ConvertFromString(value, NullToEmpty);
            }
            return NullToEmpty ? this.Empty.call(this) : undefined;
        }
    }
    get CountHandler() {
        const c = (l, args) => {
            if (args.length === 0) return;
            if (args.length === 1) return args[0];
            let v = args[0];
            for (let i = 1; i < args.length; i++) {
                if (v === undefined) v = '';
                v = Count(v, args[i], l);
            }
            return v;
        }
        return {
            "+": function () { return c('+', arguments); }
        }
    }
    get CompareHanlder() {
        return {
            "=": (a, b) => { return a === b; }
        }
    }
}
module.exports = string;